/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the TikTokConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TikTokConnectorFormAllOf{}

// TikTokConnectorFormAllOf struct for TikTokConnectorFormAllOf
type TikTokConnectorFormAllOf struct {
	// OAuthId
	OAuthId *string `json:"oAuthId,omitempty"`
	// Label
	Label *string `json:"label,omitempty"`
	// TikTok advertiser ID
	AdvertiserId *string `json:"advertiserId,omitempty"`
	// Data range expression. Required for automation
	DateRange *string `json:"dateRange,omitempty"`
	// Metrics to be included in the result
	Metric []string `json:"metric,omitempty"`
	// Data labels to be included in the result
	DataLabel []string `json:"dataLabel,omitempty"`
	// ID dimension to be included in the result
	IdDimension *string `json:"idDimension,omitempty"`
	// Audience dimension to be included in the result
	AudienceDimension *string `json:"audienceDimension,omitempty"`
	// The report type
	ReportType *string `json:"reportType,omitempty"`
	// The data level
	DataLevel *string `json:"dataLevel,omitempty"`
}

// NewTikTokConnectorFormAllOf instantiates a new TikTokConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTikTokConnectorFormAllOf() *TikTokConnectorFormAllOf {
	this := TikTokConnectorFormAllOf{}
	return &this
}

// NewTikTokConnectorFormAllOfWithDefaults instantiates a new TikTokConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTikTokConnectorFormAllOfWithDefaults() *TikTokConnectorFormAllOf {
	this := TikTokConnectorFormAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *TikTokConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *TikTokConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *TikTokConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *TikTokConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *TikTokConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *TikTokConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetAdvertiserId returns the AdvertiserId field value if set, zero value otherwise.
func (o *TikTokConnectorFormAllOf) GetAdvertiserId() string {
	if o == nil || IsNil(o.AdvertiserId) {
		var ret string
		return ret
	}
	return *o.AdvertiserId
}

// GetAdvertiserIdOk returns a tuple with the AdvertiserId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokConnectorFormAllOf) GetAdvertiserIdOk() (*string, bool) {
	if o == nil || IsNil(o.AdvertiserId) {
		return nil, false
	}
	return o.AdvertiserId, true
}

// HasAdvertiserId returns a boolean if a field has been set.
func (o *TikTokConnectorFormAllOf) HasAdvertiserId() bool {
	if o != nil && !IsNil(o.AdvertiserId) {
		return true
	}

	return false
}

// SetAdvertiserId gets a reference to the given string and assigns it to the AdvertiserId field.
func (o *TikTokConnectorFormAllOf) SetAdvertiserId(v string) {
	o.AdvertiserId = &v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *TikTokConnectorFormAllOf) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokConnectorFormAllOf) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *TikTokConnectorFormAllOf) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *TikTokConnectorFormAllOf) SetDateRange(v string) {
	o.DateRange = &v
}

// GetMetric returns the Metric field value if set, zero value otherwise.
func (o *TikTokConnectorFormAllOf) GetMetric() []string {
	if o == nil || IsNil(o.Metric) {
		var ret []string
		return ret
	}
	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokConnectorFormAllOf) GetMetricOk() ([]string, bool) {
	if o == nil || IsNil(o.Metric) {
		return nil, false
	}
	return o.Metric, true
}

// HasMetric returns a boolean if a field has been set.
func (o *TikTokConnectorFormAllOf) HasMetric() bool {
	if o != nil && !IsNil(o.Metric) {
		return true
	}

	return false
}

// SetMetric gets a reference to the given []string and assigns it to the Metric field.
func (o *TikTokConnectorFormAllOf) SetMetric(v []string) {
	o.Metric = v
}

// GetDataLabel returns the DataLabel field value if set, zero value otherwise.
func (o *TikTokConnectorFormAllOf) GetDataLabel() []string {
	if o == nil || IsNil(o.DataLabel) {
		var ret []string
		return ret
	}
	return o.DataLabel
}

// GetDataLabelOk returns a tuple with the DataLabel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokConnectorFormAllOf) GetDataLabelOk() ([]string, bool) {
	if o == nil || IsNil(o.DataLabel) {
		return nil, false
	}
	return o.DataLabel, true
}

// HasDataLabel returns a boolean if a field has been set.
func (o *TikTokConnectorFormAllOf) HasDataLabel() bool {
	if o != nil && !IsNil(o.DataLabel) {
		return true
	}

	return false
}

// SetDataLabel gets a reference to the given []string and assigns it to the DataLabel field.
func (o *TikTokConnectorFormAllOf) SetDataLabel(v []string) {
	o.DataLabel = v
}

// GetIdDimension returns the IdDimension field value if set, zero value otherwise.
func (o *TikTokConnectorFormAllOf) GetIdDimension() string {
	if o == nil || IsNil(o.IdDimension) {
		var ret string
		return ret
	}
	return *o.IdDimension
}

// GetIdDimensionOk returns a tuple with the IdDimension field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokConnectorFormAllOf) GetIdDimensionOk() (*string, bool) {
	if o == nil || IsNil(o.IdDimension) {
		return nil, false
	}
	return o.IdDimension, true
}

// HasIdDimension returns a boolean if a field has been set.
func (o *TikTokConnectorFormAllOf) HasIdDimension() bool {
	if o != nil && !IsNil(o.IdDimension) {
		return true
	}

	return false
}

// SetIdDimension gets a reference to the given string and assigns it to the IdDimension field.
func (o *TikTokConnectorFormAllOf) SetIdDimension(v string) {
	o.IdDimension = &v
}

// GetAudienceDimension returns the AudienceDimension field value if set, zero value otherwise.
func (o *TikTokConnectorFormAllOf) GetAudienceDimension() string {
	if o == nil || IsNil(o.AudienceDimension) {
		var ret string
		return ret
	}
	return *o.AudienceDimension
}

// GetAudienceDimensionOk returns a tuple with the AudienceDimension field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokConnectorFormAllOf) GetAudienceDimensionOk() (*string, bool) {
	if o == nil || IsNil(o.AudienceDimension) {
		return nil, false
	}
	return o.AudienceDimension, true
}

// HasAudienceDimension returns a boolean if a field has been set.
func (o *TikTokConnectorFormAllOf) HasAudienceDimension() bool {
	if o != nil && !IsNil(o.AudienceDimension) {
		return true
	}

	return false
}

// SetAudienceDimension gets a reference to the given string and assigns it to the AudienceDimension field.
func (o *TikTokConnectorFormAllOf) SetAudienceDimension(v string) {
	o.AudienceDimension = &v
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *TikTokConnectorFormAllOf) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokConnectorFormAllOf) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *TikTokConnectorFormAllOf) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *TikTokConnectorFormAllOf) SetReportType(v string) {
	o.ReportType = &v
}

// GetDataLevel returns the DataLevel field value if set, zero value otherwise.
func (o *TikTokConnectorFormAllOf) GetDataLevel() string {
	if o == nil || IsNil(o.DataLevel) {
		var ret string
		return ret
	}
	return *o.DataLevel
}

// GetDataLevelOk returns a tuple with the DataLevel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokConnectorFormAllOf) GetDataLevelOk() (*string, bool) {
	if o == nil || IsNil(o.DataLevel) {
		return nil, false
	}
	return o.DataLevel, true
}

// HasDataLevel returns a boolean if a field has been set.
func (o *TikTokConnectorFormAllOf) HasDataLevel() bool {
	if o != nil && !IsNil(o.DataLevel) {
		return true
	}

	return false
}

// SetDataLevel gets a reference to the given string and assigns it to the DataLevel field.
func (o *TikTokConnectorFormAllOf) SetDataLevel(v string) {
	o.DataLevel = &v
}

func (o TikTokConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TikTokConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.AdvertiserId) {
		toSerialize["advertiserId"] = o.AdvertiserId
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	if !IsNil(o.Metric) {
		toSerialize["metric"] = o.Metric
	}
	if !IsNil(o.DataLabel) {
		toSerialize["dataLabel"] = o.DataLabel
	}
	if !IsNil(o.IdDimension) {
		toSerialize["idDimension"] = o.IdDimension
	}
	if !IsNil(o.AudienceDimension) {
		toSerialize["audienceDimension"] = o.AudienceDimension
	}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	if !IsNil(o.DataLevel) {
		toSerialize["dataLevel"] = o.DataLevel
	}
	return toSerialize, nil
}

type NullableTikTokConnectorFormAllOf struct {
	value *TikTokConnectorFormAllOf
	isSet bool
}

func (v NullableTikTokConnectorFormAllOf) Get() *TikTokConnectorFormAllOf {
	return v.value
}

func (v *NullableTikTokConnectorFormAllOf) Set(val *TikTokConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableTikTokConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableTikTokConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTikTokConnectorFormAllOf(val *TikTokConnectorFormAllOf) *NullableTikTokConnectorFormAllOf {
	return &NullableTikTokConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableTikTokConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTikTokConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
